//-----------------------------------------------------------------------------
// 
// 		cwCu		AndroidpXbh֌WvO
// 
//  	Ver 3.21d
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define DX_MAKE

// CN[h ---------------------------------------------------------------
#include "DxThreadAndroid.h"
#include "../DxMemory.h"
#include "../DxBaseFunc.h"
#include <unistd.h>

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` -----------------------------------------------------------------

#define THREAD_STACK_SIZE				(128 * 1024)			// Xbh̃X^bNTCY

#define THREAD_SUSPEND_EVENT_BIT		(0x00000001)			// x~ԏp̃Cxg̃rbg

// \̐錾 -----------------------------------------------------------------

// f[^` -----------------------------------------------------------------

// ֐錾 -------------------------------------------------------------------

// vO -----------------------------------------------------------------

// Xbh̏
extern void Thread_Initialize( void )
{
	return ;
}

// Xbhs֐
static void * ThreadRunFunction( void *pArgBlock )
{
	THREAD_INFO *pInfo = ( THREAD_INFO * )pArgBlock ;

	Thread_Suspend( pInfo ) ;

	// Xbh쐬ɓnꂽ֐s
	pInfo->pFunction( pInfo, pInfo->pParam ) ;

	return NULL ;
}

// Xbh쐬
extern int Thread_Create( THREAD_INFO *pThreadInfo, void ( *pFunction )( THREAD_INFO *, void * ), void *pParam )
{
	// l
	pThreadInfo->Thread_valid		= 0 ;
	pThreadInfo->Threadattr_valid	= 0 ;
	pThreadInfo->Cond_valid			= 0 ;
	pThreadInfo->Mutex_valid		= 0 ;
	pThreadInfo->Mutexaddr_valid	= 0 ;
	pThreadInfo->SuspendFlag		= FALSE ;

	// p[^̕ۑ
	pThreadInfo->pFunction	= pFunction ;
	pThreadInfo->pParam		= pParam ;

	// ~[ebNX̏
	if( pthread_mutexattr_init( &pThreadInfo->Mutexattr ) != 0 )
	{
		goto ERR ;
	}
	pThreadInfo->Mutexaddr_valid = 1 ;

	// ċAbN\ɂ
	if( pthread_mutexattr_settype( &pThreadInfo->Mutexattr, PTHREAD_MUTEX_RECURSIVE ) != 0 )
	{
		goto ERR ;
	}

	// ~[ebNX̍쐬
	if( pthread_mutex_init( &pThreadInfo->Mutex, &pThreadInfo->Mutexattr ) != 0 )
	{
		goto ERR ;
	}
	pThreadInfo->Mutex_valid = 1 ;

	// ϐ̍쐬
	if( pthread_cond_init( &pThreadInfo->Cond, NULL ) != 0 )
	{
		goto ERR ;
	}
	pThreadInfo->Cond_valid = 1 ;

	// Xbh̏
	if( pthread_attr_init( &pThreadInfo->Threadattr ) != 0 )
	{
		goto ERR ;
	}
	pThreadInfo->Threadattr_valid = 1 ;

	// Xbh̃Zbg
//	if( pthread_attr_setdetachstate( &pThreadInfo->Threadattr, PTHREAD_CREATE_DETACHED ) != 0 )
//	{
//		goto ERR ;
//	}

	// X^bNTCỸZbg
	if( pthread_attr_setstacksize( &pThreadInfo->Threadattr, THREAD_STACK_SIZE ) != 0 )
	{
		goto ERR ;
	}

	// Xbh̍쐬
	if( pthread_create( &pThreadInfo->Thread, &pThreadInfo->Threadattr, ThreadRunFunction, pThreadInfo ) != 0 )
	{
		goto ERR ;
	}
	pThreadInfo->Thread_valid = 1 ;

	// I
	return 0 ;

ERR :

	if( pThreadInfo->Mutex_valid )
	{
		pthread_mutex_destroy( &pThreadInfo->Mutex ) ;
		pThreadInfo->Mutex_valid = 0 ;
	}

	if( pThreadInfo->Mutexaddr_valid )
	{
		pthread_mutexattr_destroy( &pThreadInfo->Mutexattr ) ;
		pThreadInfo->Mutexaddr_valid = 0 ;
	}

	if( pThreadInfo->Cond_valid )
	{
		pthread_cond_destroy( &pThreadInfo->Cond ) ;
		pThreadInfo->Cond_valid = 0 ;
	}

	if( pThreadInfo->Threadattr_valid )
	{
		pthread_attr_destroy( &pThreadInfo->Threadattr ) ;
		pThreadInfo->Threadattr_valid = 0 ;
	}

	if( pThreadInfo->Thread_valid )
	{
		pthread_detach( pThreadInfo->Thread ) ;
		pThreadInfo->Thread_valid = 0 ;
	}

	// G[I
	return -1 ;
}

// Xbȟns
extern void Thread_Delete( THREAD_INFO *pThreadInfo )
{
	if( pThreadInfo->Mutex_valid )
	{
		pthread_mutex_destroy( &pThreadInfo->Mutex ) ;
		pThreadInfo->Mutex_valid = 0 ;
	}

	if( pThreadInfo->Mutexaddr_valid )
	{
		pthread_mutexattr_destroy( &pThreadInfo->Mutexattr ) ;
		pThreadInfo->Mutexaddr_valid = 0 ;
	}

	if( pThreadInfo->Cond_valid )
	{
		pthread_cond_destroy( &pThreadInfo->Cond ) ;
		pThreadInfo->Cond_valid = 0 ;
	}

	if( pThreadInfo->Threadattr_valid )
	{
		pthread_attr_destroy( &pThreadInfo->Threadattr ) ;
		pThreadInfo->Threadattr_valid = 0 ;
	}

	if( pThreadInfo->Thread_valid )
	{
		pthread_detach( pThreadInfo->Thread ) ;
		pThreadInfo->Thread_valid = 0 ;
	}
}

// XbhLǂ擾( 1:L  0: )
extern int Thread_IsValid( THREAD_INFO *pThreadInfo )
{
	return pThreadInfo->Thread_valid ;
}


// Xbh̎sD揇ʂݒ肷
extern void Thread_SetPriority( THREAD_INFO *pThreadInfo, int Priority /* DX_THREAD_PRIORITY_LOWEST Ȃ */ )
{
	sched_param param ;
	volatile static int InitPriorityTable = 0 ;
	volatile static int PriorityTable[ DX_THREAD_PRIORITY_NUM ] ;

	if( Priority < 0 || Priority >= DX_THREAD_PRIORITY_NUM )
	{
		return ;
	}

	if( InitPriorityTable == 0 )
	{
		int MinPrio ;
		int MaxPrio ;

		MaxPrio = sched_get_priority_max( SCHED_NORMAL ) ;
		MinPrio = sched_get_priority_min( SCHED_NORMAL ) ;

		PriorityTable[ DX_THREAD_PRIORITY_LOWEST       ] = ( MaxPrio - MinPrio ) * 0 / 3 + MinPrio ;
		PriorityTable[ DX_THREAD_PRIORITY_BELOW_NORMAL ] = ( MaxPrio - MinPrio ) * 1 / 3 + MinPrio ;
		PriorityTable[ DX_THREAD_PRIORITY_NORMAL       ] = ( MaxPrio - MinPrio ) * 2 / 3 + MinPrio ;
		PriorityTable[ DX_THREAD_PRIORITY_HIGHEST      ] = ( MaxPrio - MinPrio ) * 3 / 3 + MinPrio ;

		InitPriorityTable = 1 ;
	}
	
	param.sched_priority = PriorityTable[ Priority ] ;
	pthread_setschedparam( pThreadInfo->Thread, SCHED_NORMAL, &param ) ;
}

// JgXbĥhc擾
extern DWORD_PTR Thread_GetCurrentId( void )
{
	return ( DWORD_PTR )pthread_self() ;
}

// Xbĥhc擾
extern DWORD_PTR Thread_GetId( THREAD_INFO *pThreadInfo )
{
	return ( DWORD_PTR )pThreadInfo->Thread ;
}

// Xbhx~Ԃɂ
extern void Thread_Suspend( THREAD_INFO *pThreadInfo )
{
	// ~[ebNXbN
	pthread_mutex_lock( &pThreadInfo->Mutex ) ;

	// x~Ԃ̃tO𗧂Ă
	pThreadInfo->SuspendFlag = TRUE ;

	// VOi҂ɂ
	pthread_cond_wait( &pThreadInfo->Cond, &pThreadInfo->Mutex ) ;

	// ~[ebNXAbN
	pthread_mutex_unlock( &pThreadInfo->Mutex ) ;
}

// Xbh̋x~Ԃ( 0:x~ԂȂ  1:x~Ԃ )
extern int Thread_Resume( THREAD_INFO *pThreadInfo )
{
	// ~[ebNXbN
	pthread_mutex_lock( &pThreadInfo->Mutex ) ;

	// x~Ԃł͂Ȃ炷ɔ
	if( pThreadInfo->SuspendFlag == FALSE )
	{
		// ~[ebNXAbN
		pthread_mutex_unlock( &pThreadInfo->Mutex ) ;

		// x~Ԃł͂Ȃ̖߂l
		return 0 ;
	}

	// x~Ԃ̃tO|
	pThreadInfo->SuspendFlag = FALSE ;

	// VOi𑗂
	pthread_cond_signal( &pThreadInfo->Cond ) ; 

	// ~[ebNXAbN
	pthread_mutex_unlock( &pThreadInfo->Mutex ) ;

	// x~Ԃ̖߂l
	return 1 ;
}

// w莞ԃXbh~
extern void Thread_Sleep( DWORD MiliSecond )
{
	usleep( MiliSecond * 1000 ) ;
}





// NeBJZNV̏
extern int CriticalSection_Initialize( DX_CRITICAL_SECTION *pCSection )
{
	pCSection->Mutex_valid		= 0 ;
	pCSection->Mutexaddr_valid	= 0 ;

	// ~[ebNX̏
	if( pthread_mutexattr_init( &pCSection->Mutexattr ) != 0 )
	{
		goto ERR ;
	}
	pCSection->Mutexaddr_valid = 1 ;

	// ċAbN\ɂ
	if( pthread_mutexattr_settype( &pCSection->Mutexattr, PTHREAD_MUTEX_RECURSIVE ) != 0 )
	{
		goto ERR ;
	}

	// ~[ebNX̍쐬
	if( pthread_mutex_init( &pCSection->Mutex, &pCSection->Mutexattr ) != 0 )
	{
		goto ERR ;
	}
	pCSection->Mutex_valid = 1 ;

#if defined( _DEBUG )
	int i ;
	for( i = 0 ; i < 256 ; i ++ )
	{
		pCSection->FilePath[ 0 ] = '\0' ;
	}
#endif

	return 0 ;

ERR :

	if( pCSection->Mutex_valid )
	{
		pthread_mutex_destroy( &pCSection->Mutex ) ;
		pCSection->Mutex_valid = 0 ;
	}

	if( pCSection->Mutexaddr_valid )
	{
		pthread_mutexattr_destroy( &pCSection->Mutexattr ) ;
		pCSection->Mutexaddr_valid = 0 ;
	}

	return -1 ;
}

// NeBJZNV̍폜
extern int CriticalSection_Delete( DX_CRITICAL_SECTION *pCSection )
{
	if( pCSection->Mutex_valid )
	{
		pthread_mutex_destroy( &pCSection->Mutex ) ;
		pCSection->Mutex_valid = 0 ;
	}

	if( pCSection->Mutexaddr_valid )
	{
		pthread_mutexattr_destroy( &pCSection->Mutexattr ) ;
		pCSection->Mutexaddr_valid = 0 ;
	}

	return 0 ;
}

// NeBJZNṼbN̎擾
//#if defined( _DEBUG )
#if 1
extern int CriticalSection_Lock( DX_CRITICAL_SECTION *pCSection, const char *FilePath, int LineNo )
#else
extern int CriticalSection_Lock( DX_CRITICAL_SECTION *pCSection )
#endif
{
#if defined( _DEBUG )
	DWORD_PTR ThreadID = Thread_GetCurrentId() ;
#endif

	// ~[ebNXbN
	pthread_mutex_lock( &pCSection->Mutex ) ;

#if defined( _DEBUG )
	int Length = ( int )_STRLEN( FilePath ) ;
	if( Length >= 512 ) Length = 511 ;
	_MEMCPY( pCSection->FilePath, FilePath, ( size_t )Length ) ;
	pCSection->FilePath[ Length ] = '\0' ;
	pCSection->LineNo = LineNo ;
	pCSection->ThreadID = ThreadID ;
#endif

	return 0 ;
}

// NeBJZNṼbN
extern int CriticalSection_Unlock( DX_CRITICAL_SECTION *pCSection )
{
	// ~[ebNX
	pthread_mutex_unlock( &pCSection->Mutex ) ;

	return 0 ;
}




#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

