// -------------------------------------------------------------------------------
// 
// 		cwCu		֘AvO
// 
// 				Ver 3.21d
// 
// -------------------------------------------------------------------------------

// cwCu쐬p`
#define DX_MAKE

// CN[h ------------------------------------------------------------------
#include "DxMemory.h"
#include "DxLib.h"
#include "DxStatic.h"
#include "DxBaseFunc.h"
#include "DxSystem.h"
#include "DxLog.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

#define DXMEMORY_ALIGNED				(16)						// ̃AC


#if defined( DX_THREAD_SAFE ) || defined( DX_THREAD_SAFE_NETWORK_ONLY )

#define DX_ALLOC_ENTER_CRITICAL_SECTION\
	if( MemData.InitMemoryAllocCriticalSection == 0 )\
	{\
		/* mہApNeBJZNV̏ */\
		CriticalSection_Initialize( &MemData.MemoryAllocCriticalSection ) ;\
		MemData.InitMemoryAllocCriticalSection = 1 ;\
	}\
\
	/* mۊ֌W̏s̏ꍇ͑҂ */\
	CRITICALSECTION_LOCK( &MemData.MemoryAllocCriticalSection ) ;

#define DX_ALLOC_LEAVE_CRITICAL_SECTION\
	/* ̊֐gpAtO| */\
	CriticalSection_Unlock( &MemData.MemoryAllocCriticalSection ) ;

#else

#define DX_ALLOC_ENTER_CRITICAL_SECTION
#define DX_ALLOC_LEAVE_CRITICAL_SECTION

#endif

// \̒` --------------------------------------------------------------------

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

MEMORYDATA MemData ;

// ֐vg^Cv錾-----------------------------------------------------------

static	void		DxPrintAllocSize( void ) ;													// ̊mۑʂo͂

// vO --------------------------------------------------------------------

// ̊mۑʂo͂
static void DxPrintAllocSize( void )
{
	DXST_LOGFILEFMT_ADDW(( L"\tTotal size:%d(%.3fkb)  Alloc num:%d",MemData.AllocMemorySize, MemData.AllocMemorySize / 1024.0F, MemData.AllocMemoryNum )) ;
}

// ̏s
extern int MemoryInitialize( void )
{
	DX_ALLOC_ENTER_CRITICAL_SECTION

	// ɏĂ牽Ȃ
	if( MemData.InitializeFlag )
	{
		DX_ALLOC_LEAVE_CRITICAL_SECTION
		return 0 ;
	}

	// tO𗧂Ă
	MemData.InitializeFlag = TRUE ;

	// ˑ
	if( MemoryInitialize_PF() < 0 )
	{
		DX_ALLOC_LEAVE_CRITICAL_SECTION
		return 1 ;
	}

	// mۗp̃q[v
	InitializeHeap(
		&MemData.SmallHeap,
		ALLOCMEMTYPE_TLSF,
		DXMEMORY_ALIGNED,
		TRUE,
		DXMEMORY_SMALLHEAP_UNITSIZE,
		0,
		NormalMemory_AutoAlloc_CreateHeapCallback_PF,
		NormalMemory_AutoAlloc_GetHeapAddressCallback_PF,
		NormalMemory_AutoAlloc_GetHeapSizeCallback_PF,
		NormalMemory_AutoAlloc_DeleteHeapCallback_PF
	) ;

	// 傫mۗp̃q[v
	InitializeHeap(
		&MemData.BigHeap,
		ALLOCMEMTYPE_TLSF,
		DXMEMORY_ALIGNED,
		TRUE,
		DXMEMORY_BIGHEAP_UNITSIZE,
		0,
		NormalMemory_AutoAlloc_CreateHeapCallback_PF,
		NormalMemory_AutoAlloc_GetHeapAddressCallback_PF,
		NormalMemory_AutoAlloc_GetHeapSizeCallback_PF,
		NormalMemory_AutoAlloc_DeleteHeapCallback_PF
	) ;

	DX_ALLOC_LEAVE_CRITICAL_SECTION

	// I
	return 0 ;
}

// ̌ns
extern int MemoryTerminate( void )
{
	DX_ALLOC_ENTER_CRITICAL_SECTION

	// ɌnĂ牽Ȃ
	if( MemData.InitializeFlag == FALSE )
	{
		DX_ALLOC_LEAVE_CRITICAL_SECTION
		return 0 ;
	}

	// tO|
	MemData.InitializeFlag = FALSE ;

	// mۗp̃q[v̌n
	TerminateHeap( &MemData.SmallHeap ) ;

	// 傫mۗp̃q[v̌n
	TerminateHeap( &MemData.BigHeap ) ;

	// ˑ
	MemoryTerminate_PF() ;

	DX_ALLOC_LEAVE_CRITICAL_SECTION

	// I
	return 0 ;
}

// ̎I
extern int MemoryProcess( void )
{
	int Time ;
	int NowTime ;
	WORD NowSec ;

	DX_ALLOC_ENTER_CRITICAL_SECTION

	Time = NS_GetNowCount() ;
	if( Time < MemData.StartTime )
	{
		NowTime = ( 0x7fffffff - MemData.StartTime ) + Time ;
	}
	else
	{
		NowTime = Time - MemData.StartTime ;
	}
	NowSec = ( WORD )( NowTime / 1000 ) ;

	// q[vɌ݂̕bZbg
	SetHeapTime( &MemData.SmallHeap, NowSec ) ;
	SetHeapTime( &MemData.BigHeap,   NowSec ) ;

	// ˑ
	if( MemoryProcess_PF() < 0 )
	{
		DX_ALLOC_LEAVE_CRITICAL_SECTION
		return -1 ;
	}

	DX_ALLOC_LEAVE_CRITICAL_SECTION

	// I
	return 0 ;
}

// ̊mۏ󋵂`悷
extern int MemoryDrawAllocInfo( int x, int y, int Width, int Height )
{
	ALLOCMEM_SIZE_TYPE TotalSize ;
	ALLOCMEM_SIZE_TYPE SmallSize ;
	ALLOCMEM_SIZE_TYPE BigSize ;
	int SmallHeight ;
	int BigHeight ;

	SmallSize = GetHeapTotalMemorySize( &MemData.SmallHeap ) ;
	BigSize   = GetHeapTotalMemorySize( &MemData.BigHeap ) ;
	TotalSize = SmallSize + BigSize ;

	SmallHeight = ( int )( SmallSize * ( ALLOCMEM_SIZE_TYPE )Height / TotalSize ) ;
	BigHeight   = Height - SmallHeight ;

	HeapDrawAllocInfo( &MemData.SmallHeap, x, y,               Width, SmallHeight ) ;
	HeapDrawAllocInfo( &MemData.BigHeap,   x, y + SmallHeight, Width, BigHeight   ) ;

	return 0 ;
}









// mیn֐

// DxAlloc ̓p֐
extern void *DxAllocBase( size_t AllocSize, size_t Aligned, const char *File, int Line, int NoMemoryDump )
{
	void *ReturnAddress ;

	DX_ALLOC_ENTER_CRITICAL_SECTION

	{
		HEAPINFO *Heap ;

		// ̏sĂȂ珉s
		if( MemData.InitializeFlag == FALSE )
		{
			if( MemoryInitialize() < 0 )
			{
				DX_ALLOC_LEAVE_CRITICAL_SECTION
				return NULL ;
			}
		}

		// [oCg̊mێw肾ꍇ1oCgɂ
		if( AllocSize == 0 )
		{
			AllocSize = 1 ;
		}

		// ̊m
		Heap = AllocSize > DXMEMORY_SMALL_MAX_SIZE ? &MemData.BigHeap : &MemData.SmallHeap ;
		ReturnAddress = AllocMemory( Heap, AllocSize, Aligned, FALSE, File, Line, NoMemoryDump ) ;
		if( ReturnAddress == NULL )
		{
			goto ERR ;
		}

		// Ăꍇ̓Oo͂
		if( ( int )MemData.AllocTrapSize < 0 || MemData.AllocTrapSize == AllocSize || MemData.AllocMemoryPrintFlag == TRUE )
		{
			DXST_LOGFILE_ADDW( L"mem alloc  " ) ;
			PrintInfoMemory( ReturnAddress ) ;
		}
	}

	// mۂ̑ʂƑZ
	MemData.AllocMemorySize += GetAllocSize( ReturnAddress ) ;
	MemData.AllocMemoryNum ++ ;

	// mۂĂ郁̑ʂo͂
	if( MemData.AllocMemorySizeOutFlag == TRUE )
	{
		DxPrintAllocSize() ;
	}

	// j̃`FbN
	if( MemData.AllocMemoryErrorCheckFlag == TRUE )
	{
		NS_DxErrorCheckAlloc() ;
	}

	DX_ALLOC_LEAVE_CRITICAL_SECTION

	// AhXԂ
	return ReturnAddress ;

ERR :
	// Ȃ炻̎̃_v
	NS_DxDumpAlloc() ;

	// G[o͂
	NS_DxErrorCheckAlloc() ;

	DX_ALLOC_LEAVE_CRITICAL_SECTION

	return NULL ;
}


// mۂ
extern void *NS_DxAlloc( size_t AllocSize, const char *File, int Line )
{
	return DxAllocBase( AllocSize, 0, File, Line ) ;
}

// w̃TCỸmۂ( ACw )( AllocSize:mۂ郁̃TCY( P:byte )  Alignment:mۂ郁̈̃AhXl̔{  File:DxAllocĂ񂾃\[Xt@C( fobOp )  Line:DxAllocĂ񂾃\[Xt@C̍sԍ( fobOp )@@߂l  NULL:̊mێs   NULLȊO:mۂ̈̐擪AhX )
extern void* NS_DxAllocAligned( size_t AllocSize, size_t Alignment, const char *File, int Line )
{
	return DxAllocBase( AllocSize, Alignment, File, Line ) ;
}

// mۂĂOŏ
extern void *NS_DxCalloc( size_t AllocSize, const char *File, int Line )
{
	void *buf ;

	// ̊m
	buf = DxAllocBase( AllocSize, 0, File, Line ) ;
	if( buf == NULL )
	{
		return NULL ;
	}
	
	// mۂ
	_MEMSET( buf, 0, AllocSize ) ;

	// mۂ̃AhXԂ
	return buf ;
}

// mۂĂOŏ
extern void *NS_DxCallocAligned( size_t AllocSize, size_t Alignment, const char *File, int Line )
{
	void *buf ;

	// ̊m
	buf = DxAllocBase( AllocSize, Alignment, File, Line ) ;
	if( buf == NULL )
	{
		return NULL ;
	}
	
	// mۂ
	_MEMSET( buf, 0, AllocSize ) ;

	// mۂ̃AhXԂ
	return buf ;
}

// DxRealloc ̓p֐
extern void *DxReallocBase( void *Memory, size_t AllocSize, size_t Aligned, const char *File, int Line )
{
	void *ReturnAddress ;

	if( Memory == NULL )
	{
		ReturnAddress = DxAllocBase( AllocSize, Aligned, File, Line ) ;

		return ReturnAddress ;
	}

	DX_ALLOC_ENTER_CRITICAL_SECTION

	ALLOCMEM_SIZE_TYPE PrevSize = GetAllocSize( Memory ) ;

	ReturnAddress = ReallocMemory( Memory, FALSE, AllocSize, Aligned, File, Line ) ;
	if( ReturnAddress == NULL )
	{
		goto ERR ;
	}

	// mۂ̑ʂ̏C
	MemData.AllocMemorySize -= PrevSize ;
	MemData.AllocMemorySize += GetAllocSize( ReturnAddress ) ;

	// Ăꍇ̓Oo͂
	if( (int)MemData.AllocTrapSize < 0 || MemData.AllocTrapSize == AllocSize || MemData.AllocMemoryPrintFlag == TRUE )
	{
		DXST_LOGFILE_ADDW( L"mem realloc  " ) ;
		PrintInfoMemory( Memory ) ;
	}

	// mۂĂ郁̑ʂo͂
	if( MemData.AllocMemorySizeOutFlag == TRUE )
	{
		DxPrintAllocSize() ;
	}

	// j̃`FbN
	if( MemData.AllocMemoryErrorCheckFlag == TRUE )
	{
		NS_DxErrorCheckAlloc() ;
	}

	DX_ALLOC_LEAVE_CRITICAL_SECTION

	// mۂAhXԂ
	return ReturnAddress ;

ERR :
	// Ȃ炻̎̃_v
	NS_DxDumpAlloc() ;

	DX_ALLOC_LEAVE_CRITICAL_SECTION

	return NULL ;
}

// ̍Ċmۂs
extern void *NS_DxRealloc( void *Memory, size_t AllocSize, const char *File, int Line )
{
	return DxReallocBase( Memory, AllocSize, 0, File, Line ) ;
}

// ̍Ċmۂs
extern void *NS_DxReallocAligned( void *Memory, size_t AllocSize, size_t Alignment, const char *File, int Line )
{
	return DxReallocBase( Memory, AllocSize, Alignment, File, Line ) ;
}

// 
extern void NS_DxFree( void *Memory )
{
	// NULL nꂽꍇ͉Ȃ
	if( Memory == NULL )
	{
		return ;
	}

	DX_ALLOC_ENTER_CRITICAL_SECTION

	// j̃`FbN
	if( MemData.AllocMemoryErrorCheckFlag == TRUE )
	{
		NS_DxErrorCheckAlloc() ;
	}

	ALLOCMEM_SIZE_TYPE AllocSize = GetAllocSize( Memory ) ;

	// 郁̕mۂ̑ʂƐ炷
	MemData.AllocMemorySize -= AllocSize ;
	MemData.AllocMemoryNum -- ;

	// Ăꍇ̓Oo͂
	if( (int)MemData.AllocTrapSize < 0 || MemData.AllocTrapSize == AllocSize || MemData.AllocMemoryPrintFlag == TRUE )
	{
		DXST_LOGFILE_ADDW( L"mem free  " ) ;
		PrintInfoMemory( Memory ) ;
	}

	// ̉
	FreeMemory( Memory ) ;

	// mۂĂ郁̑ʂo͂
	if( MemData.AllocMemorySizeOutFlag == TRUE )
	{
		DxPrintAllocSize() ;
	}

	DX_ALLOC_LEAVE_CRITICAL_SECTION
}

// 񋓑Ώۂɂ郁̊mۗeʂZbg
extern size_t NS_DxSetAllocSizeTrap( size_t Size )
{
	size_t trapsize ;

	trapsize = MemData.AllocTrapSize ;
	MemData.AllocTrapSize = Size ;

	return trapsize ;
}

// cwCuŃmۂs鎞ɏo͂邩ǂZbg
extern int NS_DxSetAllocPrintFlag( int Flag )
{
	int printflag ;
	
	printflag = MemData.AllocMemoryPrintFlag ;

	MemData.AllocMemoryPrintFlag = Flag ;

	return printflag ;
}

// mۂĂ郁TCY擾
extern size_t NS_DxGetAllocSize( void )
{
	return MemData.AllocMemorySize ;
}

// mۂĂ郁̐擾
extern int NS_DxGetAllocNum( void )
{
	return MemData.AllocMemoryNum ;
}

// mۂĂ郁񋓂
extern void NS_DxDumpAlloc( void )
{
	DX_ALLOC_ENTER_CRITICAL_SECTION

	DXST_LOGFILE_ADDW( L"\n" ) ;
	DXST_LOGFILE_ADDW( L"Alloc memory dump\n" ) ;

	// mۂ̏o
	HeapInfoDump( &MemData.SmallHeap ) ;

	// 傫mۂ̏o
	HeapInfoDump( &MemData.BigHeap ) ;

	DxPrintAllocSize() ;

	// ˑ̃mۂ̏o
	DxDumpAlloc_PF() ;

	DXST_LOGFILE_ADDW( L"\n" ) ;

	DX_ALLOC_LEAVE_CRITICAL_SECTION
}

// DxAlloc  DxCalloc ŊmۂĂ郁̏󋵂`悷
extern void NS_DxDrawAlloc( int x, int y, int Width, int Height )
{
	MemoryDrawAllocInfo( x, y, Width, Height ) ;
}

// mۂ񂪔j󂳂ĂȂׂ( -1:j󂠂  0:Ȃ )
extern int NS_DxErrorCheckAlloc( void )
{
	DX_ALLOC_ENTER_CRITICAL_SECTION

	// mۗp̃q[ṽG[`FbN
	if( HeapErrorCheck( &MemData.SmallHeap ) < 0 )
	{
		return -1 ;
	}

	// 傫mۗp̃q[ṽG[`FbN
	if( HeapErrorCheck( &MemData.BigHeap ) < 0 )
	{
		return -1 ;
	}

	DX_ALLOC_LEAVE_CRITICAL_SECTION

	// I
	return 0 ;
}

// mہA邽тɊmۂĂ郁̗eʂo͂邩ǂ̃tOZbg
extern int NS_DxSetAllocSizeOutFlag( int Flag )
{
	int OutFlag ;

	OutFlag = MemData.AllocMemorySizeOutFlag ;
	MemData.AllocMemorySizeOutFlag = Flag ;

	return OutFlag ;
}

// ̊mہAsxɊmۂĂ郁mۏ񂪔jĂȂׂ邩ǂ̃tOZbg
extern int NS_DxSetAllocMemoryErrorCheckFlag( int Flag )
{
	int CheckFlag ;

	CheckFlag = MemData.AllocMemoryErrorCheckFlag ;
	MemData.AllocMemoryErrorCheckFlag = Flag ;

	return CheckFlag ;
}

// _v
extern void	MemoryDump( void *buffer, int size )
{
#ifndef DX_NON_LITERAL_STRING
	BYTE *dp ;
	int i, j, linenum ;
	wchar_t string[128], string2[128], *sp = NULL, *sp2 = NULL ;

	DXST_LOGFILE_ADDW( L"\n" ) ;
	linenum = size / 16 ;
	dp = (BYTE *)buffer ;
	for( i = 0 ; i < linenum ; i ++, dp += 16 )
	{
		DXST_LOGFILEFMT_ADDW(( L"%08x : %02x %02x %02x %02x  %02x %02x %02x %02x  %02x %02x %02x %02x  %02x %02x %02x %02x : %C%C%C%C %C%C%C%C %C%C%C%C %C%C%C%C\n",
			dp, dp[0], dp[1], dp[2], dp[3],  dp[4], dp[5], dp[6], dp[7],  dp[8], dp[9], dp[10], dp[11],  dp[12], dp[13], dp[14], dp[15],
			dp[0], dp[1], dp[2], dp[3],  dp[4], dp[5], dp[6], dp[7],  dp[8], dp[9], dp[10], dp[11],  dp[12], dp[13], dp[14], dp[15] )) ;
	}

	size -= linenum * 16 ;
	j     = 0 ;
	for( i = 0 ; i < size ; i ++, dp ++ )
	{
		if( j == 0 )
		{
			sp  = string  ;
			sp2 = string2 ;
			_SWPRINTF( sp, L"%08x : ", dp ) ;
			sp += 11 ;
		}

		_SWPRINTF( sp, L"%02x ", *dp ) ;
		sp += 3 ;
		sp2[0] = ( wchar_t )*dp ;
		sp2[1] = '\0' ;
		sp2 ++ ;

		j ++ ;
		if( j == 16 )
		{
			_SWPRINTF( sp, L": %s\n", string2 ) ;
			DXST_LOGFILE_ADDW( string ) ;
			j = 0 ;
		}
	}
	if( j != 0 )
	{
		_SWPRINTF( sp, L": %s\n", string2 ) ;
		DXST_LOGFILE_ADDW( string ) ;
	}
#endif
}









#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE
